--author: igor29381
--Giants's functions Fillable.onAttach and Fillable.onDetach works is not correctly on different combinations of attacherPipe and attacherPipeRef
--It's a corrected code

function Fillable:onAttach(attacherVehicle)
	if self.attacherPipe then
		local vehicle = Fillable.searchAttacherPipeVehicle(attacherVehicle, "attacherPipeRef");
		if vehicle then
			self:attachPipe(self, vehicle);
		end;
	elseif self.attacherPipeRef then
		local vehicle = Fillable.searchAttacherPipeVehicle(attacherVehicle, "attacherPipe");
		if vehicle then
			vehicle:attachPipe(vehicle, self);
		end;
	end;
end;

function Fillable:onDetach()
	local detachPipe = true;
	for _,implement in pairs(self.attachedImplements) do
		if implement.object then
			if (self.attacherPipe and self.attacherPipeRefVehicle == implement.object) or
			(self.attacherPipeRef and self.attacherPipeVehicle == implement.object) then
				detachPipe = false;
				break;
			end;
		end;
	end;
	if detachPipe then
		if self.attacherPipe and self.attacherPipeRefVehicle then
			self:detachPipe();
		elseif self.attacherPipeRef and self.attacherPipeVehicle then
			self.attacherPipeVehicle:detachPipe();
		end;
	end;
end;

function Fillable.searchAttacherPipeVehicle(attacherVehicle, searchType)
	if attacherVehicle[searchType] then
		return attacherVehicle;
	end;
	if attacherVehicle.attachedImplements and #attacherVehicle.attachedImplements > 0 then
		for _,implement in pairs(attacherVehicle.attachedImplements) do
			if implement.object and implement.object[searchType] then
				return implement.object;
			end;
		end;
	end;
	local rootAttacherVehicle = attacherVehicle:getRootAttacherVehicle();
	if rootAttacherVehicle ~= attacherVehicle then
		if rootAttacherVehicle[searchType] then
			return rootAttacherVehicle;
		end;
		if rootAttacherVehicle.attachedImplements and #rootAttacherVehicle.attachedImplements > 0 then
			for _,implement in pairs(rootAttacherVehicle.attachedImplements) do
				if implement.object and implement.object[searchType] then
					return implement.object;
				end;
			end;
		end;
	end;
end;
